Project Chrono: chrono::ChIndexedParticles Class Reference

Public Member Functions | List of all members
chrono::ChIndexedParticles Class Referenceabstract

## Description

Interface class for clusters of particles that can be accessed with an index.

Must be inherited by children classes.

`#include <ChIndexedParticles.h>`

Inheritance diagram for chrono::ChIndexedParticles:
[legend]
Collaboration diagram for chrono::ChIndexedParticles:
[legend]

## Public Member Functions
| ChIndexedParticles (const ChIndexedParticles &other)
virtual size_t | GetNumParticles () const =0
| Get the number of particles.
virtual ChParticleBase & | Particle (unsigned int n)=0
| Access the N-th particle.
virtual const ChParticleBase & | Particle (unsigned int n) const =0
| Access the N-th particle.
virtual void | ResizeNparticles (int newsize)=0
| Resize the particle cluster.
virtual void | AddParticle (ChCoordsys< double > initial_state=CSYSNORM)=0
| Add a new particle to the particle cluster, passing a coordinate system as initial state.
virtual unsigned int | GetNumCoordsPosLevel () override
| Number of coordinates of the particle cluster.
virtual unsigned int | GetNumCoordsVelLevel () override
| Number of coordinates of the particle cluster.
virtual ChFrame | GetVisualModelFrame (unsigned int nclone=0) const override
| Get the reference frame (expressed in and relative to the absolute frame) of the visual model.
virtual unsigned int | GetNumVisualModelClones () const override
| Return the number of clones of the visual model associated with this physics item.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow deserialization of transient data from archives.
Public Member Functions inherited from chrono::ChPhysicsItem
| ChPhysicsItem (const ChPhysicsItem &other)
virtual ChPhysicsItem * | Clone () const override
| "Virtual" copy constructor (covariant return type).
ChSystem * | GetSystem () const
| Get the pointer to the parent ChSystem().
virtual void | SetSystem (ChSystem *m_system)
| Set the pointer to the parent ChSystem().
void | AddVisualModel (std::shared_ptr< ChVisualModel > model)
| Add an (optional) visualization model.
std::shared_ptr< ChVisualModel > | GetVisualModel () const
| Access the visualization model (if any).
void | AddVisualShape (std::shared_ptr< ChVisualShape > shape, const ChFrame<> &frame=ChFrame<>())
| Add the specified visual shape to the visualization model.
std::shared_ptr< ChVisualShape > | GetVisualShape (unsigned int i) const
| Access the specified visualization shape in the visualization model (if any).
void | AddVisualShapeFEA (std::shared_ptr< ChVisualShapeFEA > shapeFEA)
| Add the specified FEA visualization object to the visualization model.
std::shared_ptr< ChVisualShapeFEA > | GetVisualShapeFEA (unsigned int i) const
| Access the specified FEA visualization object in the visualization model (if any).
void | AddCamera (std::shared_ptr< ChCamera > camera)
| Attach a ChCamera to this physical item.
std::vector< std::shared_ptr< ChCamera > > | GetCameras () const
| Get the set of cameras attached to this physics item.
virtual bool | IsActive () const
| Return true if the object is active and included in dynamics.
virtual bool | IsCollisionEnabled () const
| Tell if the object is subject to collision.
virtual void | AddCollisionModelsToSystem (ChCollisionSystem *coll_sys) const
| Add to the provided collision system any collision models managed by this physics item.
virtual void | RemoveCollisionModelsFromSystem (ChCollisionSystem *coll_sys) const
| Remove from the provided collision system any collision models managed by this physics item.
virtual void | SyncCollisionModels ()
| Synchronize the position and bounding box of any collsion models managed by this physics item.
virtual ChAABB | GetTotalAABB ()
| Get the entire AABB axis-aligned bounding box of the object.
virtual void | GetCenter (ChVector3d &mcenter)
| Get a symbolic 'center' of the object.
virtual void | Setup ()
| This might recompute the number of coordinates, DOFs, constraints, in case this might change (ex in ChAssembly), as well as state offsets of contained items (ex in ChMesh).
virtual void | Update (double mytime, bool update_assets=true)
| This is an important function, which is called by the owner ChSystem at least once per integration step.
virtual void | Update (bool update_assets=true)
| As above, but does not require updating of time-dependent data.
virtual void | ForceToRest ()
| Set zero speed (and zero accelerations) in state, without changing the position.
virtual unsigned int | GetNumConstraints ()
| Get the number of scalar constraints.
virtual unsigned int | GetNumConstraintsBilateral ()
| Get the number of bilateral scalar constraints.
virtual unsigned int | GetNumConstraintsUnilateral ()
| Get the number of unilateral scalar constraints.
unsigned int | GetOffset_x ()
| Get offset in the state vector (position part).
unsigned int | GetOffset_w ()
| Get offset in the state vector (speed part).
unsigned int | GetOffset_L ()
| Get offset in the lagrangian multipliers.
void | SetOffset_x (const unsigned int moff)
| Set offset in the state vector (position part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_w (const unsigned int moff)
| Set offset in the state vector (speed part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_L (const unsigned int moff)
| Set offset in the lagrangian multipliers Note: only the ChSystem::Setup function should use this.
virtual void | IntStateGather (const unsigned int off_x, ChState &x, const unsigned int off_v, ChStateDelta &v, double &T)
| From item's state to global state vectors y={x,v} pasting the states at the specified offsets.
virtual void | IntStateScatter (const unsigned int off_x, const ChState &x, const unsigned int off_v, const ChStateDelta &v, const double T, bool full_update)
| From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.
virtual void | IntStateGatherAcceleration (const unsigned int off_a, ChStateDelta &a)
| From item's state acceleration to global acceleration vector.
virtual void | IntStateScatterAcceleration (const unsigned int off_a, const ChStateDelta &a)
| From global acceleration vector to item's state acceleration.
virtual void | IntStateGatherReactions (const unsigned int off_L, ChVectorDynamic<> &L)
| From item's reaction forces to global reaction vector.
virtual void | IntStateScatterReactions (const unsigned int off_L, const ChVectorDynamic<> &L)
| From global reaction vector to item's reaction forces.
virtual void | IntStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv)
| Computes x_new = x + Dt , using vectors at specified offsets.
virtual void | IntStateGetIncrement (const unsigned int off_x, const ChState &x_new, const ChState &x, const unsigned int off_v, ChStateDelta &Dv)
| Computes Dt = x_new - x, using vectors at specified offsets.
virtual void | IntLoadResidual_F (const unsigned int off, ChVectorDynamic<> &R, const double c)
| Takes the F force term, scale and adds to R at given offset: R += c*F.
virtual void | IntLoadResidual_Mv (const unsigned int off, ChVectorDynamic<> &R, const ChVectorDynamic<> &w, const double c)
| Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.
virtual void | IntLoadLumpedMass_Md (const unsigned int off, ChVectorDynamic<> &Md, double &err, const double c)
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | IntLoadResidual_CqL (const unsigned int off_L, ChVectorDynamic<> &R, const ChVectorDynamic<> &L, const double c)
| Takes the term Cq'*L, scale and adds to R at given offset: R += c*Cq'*L.
virtual void | IntLoadConstraint_C (const unsigned int off, ChVectorDynamic<> &Qc, const double c, bool do_clamp, double recovery_clamp)
| Takes the term C, scale and adds to Qc at given offset: Qc += c*C.
virtual void | IntLoadConstraint_Ct (const unsigned int off, ChVectorDynamic<> &Qc, const double c)
| Takes the term Ct, scale and adds to Qc at given offset: Qc += c*Ct.
virtual void | IntToDescriptor (const unsigned int off_v, const ChStateDelta &v, const ChVectorDynamic<> &R, const unsigned int off_L, const ChVectorDynamic<> &L, const ChVectorDynamic<> &Qc)
| Prepare variables and constraints to accommodate a solution:
virtual void | IntFromDescriptor (const unsigned int off_v, ChStateDelta &v, const unsigned int off_L, ChVectorDynamic<> &L)
| After a solver solution, fetch values from variables and constraints into vectors:
virtual void | InjectVariables (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChVariable objects associated with this item.
virtual void | InjectConstraints (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChConstraint objects associated with this item.
virtual void | LoadConstraintJacobians ()
| Compute and load current Jacobians in encapsulated ChConstraint objects.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbReset ()
| Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.
virtual void | VariablesFbLoadForces (double factor=1)
| Adds the current forces (applied to item) into the encapsulated ChVariables, in the 'fb' part: qf+=forces*factor.
virtual void | VariablesQbLoadSpeed ()
| Initialize the 'qb' part of the ChVariables with the current value of speeds.
virtual void | VariablesFbIncrementMq ()
| Adds M*q (masses multiplied current 'qb') to Fb, ex.
virtual void | VariablesQbSetSpeed (double step=0)
| Fetches the item speed (ex.
virtual void | VariablesQbIncrementPosition (double step)
| Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.
virtual void | ConstraintsBiReset ()
| Sets to zero the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_C (double factor=1, double recovery_clamp=0.1, bool do_clamp=false)
| Adds the current C (constraint violation) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Ct (double factor=1)
| Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Qc (double factor=1)
| Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsFbLoadForces (double factor=1)
| Adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints.
virtual void | ConstraintsFetch_react (double factor=1)
| Fetches the reactions from the lagrangian multiplier (l_i) of encapsulated ChConstraints.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual std::string & | ArchiveContainerName ()

## Additional Inherited Members
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()
Protected Attributes inherited from chrono::ChPhysicsItem
ChSystem * | system
| parent system
std::shared_ptr< ChVisualModelInstance > | vis_model_instance
| instantiated visualization model
std::vector< std::shared_ptr< ChCamera > > | cameras
| set of cameras
unsigned int | offset_x
| offset in vector of state (position part)
unsigned int | offset_w
| offset in vector of state (speed part)
unsigned int | offset_L
| offset in vector of lagrangian multipliers
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Member Function Documentation

## ◆ AddParticle()

virtual void chrono::ChIndexedParticles::AddParticle | ( | ChCoordsys< double > | initial_state = CSYSNORM | ) |
| pure virtual

Add a new particle to the particle cluster, passing a coordinate system as initial state.

Implemented in chrono::ChParticleCloud.

## ◆ ArchiveIn()

void chrono::ChIndexedParticles::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| overridevirtual

Method to allow deserialization of transient data from archives.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::ChParticleCloud.

## ◆ ArchiveOut()

void chrono::ChIndexedParticles::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| overridevirtual

Method to allow serialization of transient data to archives.

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::ChParticleCloud.

## ◆ GetNumCoordsPosLevel()

virtual unsigned int chrono::ChIndexedParticles::GetNumCoordsPosLevel | ( |  | ) |
| inlineoverridevirtual

Number of coordinates of the particle cluster.

(x 7 because quaternions are used for rotation)

Reimplemented from chrono::ChPhysicsItem.

## ◆ GetNumCoordsVelLevel()

virtual unsigned int chrono::ChIndexedParticles::GetNumCoordsVelLevel | ( |  | ) |
| inlineoverridevirtual

Number of coordinates of the particle cluster.

(x 6 because derivatives use angular velocity)

Reimplemented from chrono::ChPhysicsItem.

## ◆ GetNumParticles()

virtual size_t chrono::ChIndexedParticles::GetNumParticles | ( |  | ) | const
| pure virtual

Get the number of particles.

Implemented in chrono::ChParticleCloud.

## ◆ GetNumVisualModelClones()

virtual unsigned int chrono::ChIndexedParticles::GetNumVisualModelClones | ( |  | ) | const
| inlineoverridevirtual

Return the number of clones of the visual model associated with this physics item.

If the visual model is cloned (for example for a physics item modeling a particle system), this function should return the total number of copies of the visual model, including the "original". The current coordinate frame of a given clone can be obtained by calling GetVisualModelFrame() with the corresponding clone identifier.

Reimplemented from chrono::ChPhysicsItem.

## ◆ GetVisualModelFrame()

ChFrame chrono::ChIndexedParticles::GetVisualModelFrame | ( | unsigned int | nclone = 0 | ) | const
| overridevirtual

Get the reference frame (expressed in and relative to the absolute frame) of the visual model.

Base class for particle clusters.

For a ChIndexedParticles, this returns the frame of the corresponding particle.

Reimplemented from chrono::ChPhysicsItem.

## ◆ Particle() [1/2]

virtual const ChParticleBase & chrono::ChIndexedParticles::Particle | ( | unsigned int | n | ) | const
| pure virtual

Access the N-th particle.

Implemented in chrono::ChParticleCloud.

## ◆ Particle() [2/2]

virtual ChParticleBase & chrono::ChIndexedParticles::Particle | ( | unsigned int | n | ) |
| pure virtual

Access the N-th particle.

Implemented in chrono::ChParticleCloud.

## ◆ ResizeNparticles()

virtual void chrono::ChIndexedParticles::ResizeNparticles | ( | int | newsize | ) |
| pure virtual

Resize the particle cluster.

Also clear the state of previously created particles, if any.

Implemented in chrono::ChParticleCloud.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChIndexedParticles.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChIndexedParticles.cpp